import { ErrorTypeEnum, askThrowError } from 'quidproquo-core';
import { askConvertNeptuneNodeResultToGraphNodeResult } from './askConvertNeptuneNodeResultToGraphNodeResult';
import { askConvertNeptuneRelationshipResultToGraphRelationshipResult } from './askConvertNeptuneRelationshipResultToGraphRelationshipResult';
import { isNeptuneScalarResult, isNeptuneNodeResult, isNeptuneRelationshipResult } from './utils';
export function* askConvertAnyNeptuneResultToAnyGraphResult(anyNeptuneResult) {
    if (isNeptuneScalarResult(anyNeptuneResult)) {
        return anyNeptuneResult;
    }
    if (isNeptuneNodeResult(anyNeptuneResult)) {
        return yield* askConvertNeptuneNodeResultToGraphNodeResult(anyNeptuneResult);
    }
    if (isNeptuneRelationshipResult(anyNeptuneResult)) {
        return yield* askConvertNeptuneRelationshipResultToGraphRelationshipResult(anyNeptuneResult);
    }
    return yield* askThrowError(ErrorTypeEnum.GenericError, 'Unable to convert neptune query result');
}
